标签:hdu 贪心 二分查找
Pie
Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 5628 Accepted Submission(s): 2184
Problem Description
My birthday is coming up and traditionally I‘m serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one
pie, not several small pieces since that looks messy. This piece can be one whole pie though.
My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is
better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.
What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
Input
One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
Sample Input
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2
Sample Output
题意:
生日家里来了F个朋友,他家里有好N个Pie,主人希望把Pie分出F+1份(自己也要一个),要求体积相同,所有的Pie不需要都分完,问你每个人最大能分到多大体积的Pie。
思路:
贪心+二分查找
代码:
#include<iostream>
#include<iomanip>
#include<cstdio>
using namespace std;
const double pi=3.1415926535897932;
int t,n,f;
int r[10050];
int main()
{
cin>>t;
while(t--)
{
cin>>n>>f;
double r[10050];
f++;
double sum=0.0;
for(int i=1;i<=n;i++)
{
cin>>r[i];
r[i]*=r[i];
sum+=r[i];
}
double low=0.0;
double high=sum/f;
double mid;
while(high-low>0.000001)
{
mid=(low+high)/2;
int num=0;
for(int i=1;i<=n;i++)
num+=(int)(r[i]/mid);
if(num<f)
high=mid;
else
low=mid;
}
printf("%.4lf\n",pi*mid);
}
return 0;
}
版权声明:本文为博主原创文章,未经博主允许不得转载。
hdu 1969 Pie(贪心+二分查找)(简单)
标签:hdu 贪心 二分查找
原文地址:http://blog.csdn.net/kaisa158/article/details/46911953